<?php
	/**
	* Funktion myGB_umlaute()
	* Ersetzen von Umlauten
	*
	* @uses: none
	* @parameter: $string --> String dessen Umlaute ersetzt werden sollen (Gstebucheintrag)
	* @return: $string/string
	*/
	function myGB_umlaute($string)
	{
		// Alle Umlaute ersetzen [oder ganze viele ;) zumindest]
		$pattern = array('//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//', '//');
		$replace = array('&#192;', '&#193;', '&#194;', '&#195;', '&#196;', '&#197;', '&#198;', '&#199;', '&#200;', '&#201;', '&#202;', '&#203;', '&#204;', '&#205;', '&#206;', '&#207;', '&#208;', '&#209;', '&#210;', '&#211;', '&#212;', '&#213;', '&#214;', '&#215;', '&#216;', '&#217;', '&#218;', '&#219;', '&#220;', '&#221;', '&#222;', '&#223;', '&#224;', '&#225;', '&#226;', '&#227;', '&#228;', '&#229;', '&#230;', '&#231;', '&#232;', '&#233;', '&#234;', '&#235;', '&#236;', '&#237;', '&#238;', '&#239;', '&#240;', '&#241;', '&#242;', '&#243;', '&#244;', '&#245;', '&#246;', '&#247;', '&#248;', '&#249;', '&#250;', '&#251;', '&#252;', '&#253;', '&#254;', '&#255;');
		$string = preg_replace($pattern, $replace, $string); // Hier die Umlaute ersetzen
		$string = str_replace('&amp;', '&', $string); // Eventuelle &amp; durch & ersetzen
		return $string;
	}
	/**
	* Funktion myGB_check_image_size()
	* berprft ob die Ausmae von Bildern eine Breite von 550 Pixel bersteigen und die Bilder berhaupt geladen werden knnen
	*
	* @uses: none
	* @parameter: $source --> URL zum Bild
	* @return: $returnimg/string
	*/
	function myGB_check_image_size($source)
	{
		error_reporting(0);
		$imgstring = ''; // Falls das Bild verkleinert werden muss, hier Link zur Original-Grafik ausgeben
		$returnimg = '<img src="'.$source.'"'; // String mit Rckgabewert (HTML-Code fr Bilder)
		if(!$img_size = getimagesize($source)) // Bildausmae bestimmen
		return '<a href="'.$source.'" target="_blank">Sorry, but can\'t show this image</a> <small>('.wordwrap($source, 25, " ", true).')</small>';
		if($img_size[0] > 550) // berprfen, ob das Bild breiter als 550px ist
		{
			// Falls ja, auf 550px beschrnken und Hhe anpassen
			$returnimg .= ' style="width: 550px; height: '.round(($img_size[1] * 550/ $img_size[0]),0).';"';
			$imgstring = '<a href="'.$source.'" target="_blank">';
		}
		$returnimg .= ' border="0" alt="Image">'; // Rest des HTML-Codes hinzufgen
		// Falls oben ein Link hinzugefgt wurde, zu $returnimg hinzufgen
		error_reporting(E_ERROR | E_WARNING | E_PARSE);
		if($imgstring != '') $returnimg = $imgstring.$returnimg.'</a>';
		return $returnimg;
	}
	/**
	* Funktion myGB_highlightstring()
	* Highlighted PHP-Code mit highlight_string
	*
	* @uses: none
	* @parameter: $string --> PHP-Code, der gehighlighted werden soll
	* @return: string
	*/
	function myGB_highlightstring($string)
	{
		$string = str_replace('<br />', '', $string);
		$string = str_replace('<br>', '', $string);
		$string = trim($string);
	
		// PHP-Zeichen ersetzen durch HTML-Code
		$string = str_replace('&lt;?', '<?', $string);
		$string = str_replace('?&gt;', '?>', $string);
		$phpstring = highlight_string($string, true);
		$phpstring = preg_replace('#\\\\r\\\\n|\\\\r|\\\\n|\r\n|\r|\n#si', '', $phpstring);
		$phpstring = preg_replace('#<code>#si', '', $phpstring);		
		
		// Nach Zeilen-Umbrchen aufsplitten um Zeilenangaben hinzuzufgen
		$teilstring = explode('<br />', $phpstring);
		
		$returnstring = '<code>';		
		// Zeilennummern einfgen
		for($a = 0; $a < count($teilstring); $a++)
		{
			$teilstring[$a] = trim(str_replace('<br>', '', $teilstring[$a]));
			$returnstring .= '<span style="color: #010101">'.($a+1).'</span>&nbsp;&nbsp;'.$teilstring[$a].'<br>';
		}
		$returnstring = substr($returnstring, 0, (strlen($returnstring)-4));
		$returnstring = trim($returnstring);
		
		return '<div style="padding: 2px; margin: 2px; background-color: #DDDDDD; border: 1px solid black; overflow: auto"><b><small style="font-family: courier new">PHP Code:</small></b><br><big>'.trim($returnstring).'</big></div>';
	}
	/**
	* Funktion myGB_bbcodesmilie()
	* Wandelt BB-Code im String um anhand von regulren Ausdrcken
	*
	* @uses: myGB_umlaute(), myGB_check_image_size(), myGB_highlightstring()
	* @parameter: $string --> Gstebucheintrag, dessen BB-Code in HTML ungewandelt werden soll
	* @return: $string/string
	*/
	function myGB_bbcodesmilie($string, $admin=false)
	{
		// Falls der BBCode-Filter von der Administration aufgerufen wird, Pfad fr Smilies anpassen
		if($admin == true)
		{
			// Config-Datei einbinden zum Auslesen des Smiliespfads
			include("../../myGB-config.inc.php");
			// berprfen ob der Pfad nicht extern ist (http://www.url.de/smilies/...)
			if(substr($smileypath, 0, 7) != 'http://' and substr($smileypath, 0, 6) != 'ftp://') $smileypath = '../../'.$smileypath;
		}
		else
		{
			include('myGB-config.inc.php');
		}	
	
		// Umlaute ersetzen
		$string = myGB_umlaute($string);
		// Diese beiden Zeichen ersetzen, damit kein Smilie daraus gemacht wird (wegen ;) und ;D)
		$string = str_replace('&quot;)', '")', $string); 
		$string = str_replace('&quot;D', '"D', $string);
		$string = preg_replace('#(ftp|http)://#si', '$1[tempadress]', $string);
		// Smilies ersetzen		
		$string = preg_replace('#(:-\()|(:\*(-{0,1})\()|(:\'(-{0,1})\()#s', '<img src="smilies/cry.gif" alt="cry">', $string);
		$string = preg_replace('#\):(-{0,1})\(#s', '<img src="smilies/angry.gif" alt="Angry">', $string);
		$string = preg_replace('#8(-{0,1})\[#s', '<img src="smilies/blaze.gif" alt="Blaze">', $string);
		$string = preg_replace('#:(-{0,1})D#s', '<img src="smilies/cheesy.gif" alt="Cheesy">', $string);
		$string = preg_replace('#8(-{0,1})\)#s', '<img src="smilies/cool.gif" alt="Cool">', $string);
		$string = preg_replace('#8(-{0,1})\)#s', '<img src="smilies/cool.gif" alt="Cool">', $string);
		$string = preg_replace('#:-\[#s', '<img src="smilies/embarassed.gif" alt="Embarassed">', $string);
		$string = preg_replace('#;(-{0,1})D#s', '<img src="smilies/grin.gif" alt="Grin">', $string);
		$string = preg_replace('#(\?\?\?+)|(&\#129;&\#129;&\#129;)#s', '<img src="smilies/huh.gif" alt="Huh">', $string);
		$string = preg_replace('#:(-{0,1})X#si', '<img src="smilies/lipsrsealed.gif" alt="Lips are sealed">', $string);
		$string = preg_replace('#::(-{0,1})\]#s', '<img src="smilies/rolleyes.gif" alt="Rolleyes">', $string);
		$string = preg_replace('#:\(#s', '<img src="smilies/sad.gif" alt="Sad">', $string);
		$string = preg_replace('#(:(-{0,1})(o|0|O))#s', '<img src="smilies/shocked.gif" alt="Shocked">', $string);
		$string = preg_replace('#:(-{0,1})\)#s', '<img src="smilies/smiley.gif" alt="Smiley">', $string);
		$string = preg_replace('#:(-{0,1})P#si', '<img src="smilies/tongue.gif" alt="Tongue">', $string);
		$string = preg_replace('#:(-{0,1})\*#s', '<img src="smilies/kiss.gif" alt="Kiss">', $string);
		$string = preg_replace('#:(-{0,1})/#s', '<img src="smilies/undecided.gif" alt="Undecided">', $string);
		$string = preg_replace('#;(-{0,1})\)#s', '<img src="smilies/wink.gif" alt="Wink">', $string);
		$string = preg_replace('#\(\):(-{0,1})\)#s', '<img src="smilies/angel_smile.gif" alt="Angel Smile">', $string);
		$string = preg_replace('#\(\):(-{0,1})\)#s', '<img src="smilies/angel_smile.gif" alt="Angel Smile">', $string);
		$string = preg_replace('#(\[heart\])|(\[love\])#si', '<img src="smilies/heart.gif" alt="Heart">', $string);
		$string = preg_replace('#(\[light\])|(\[idea\])#si', '<img src="smilies/lightbulb.gif" alt="Lightbulb">', $string);
		// Ersetzungen von oben wieder rckgangig machen
		$string = preg_replace('#(ftp|http)\[tempadress\]#si', '$1://', $string);	
		// erste "einfache" Formatierungen ersetzen		
		$string = preg_replace('#\[b\](.*?)\[/b\]#mis', '<b>$1</b>', $string);
		$string = preg_replace('#\[d\](.*?)\[/d\]#mis', '<span style="text-decoration: line-through">$1</span>', $string);
		$string = preg_replace('#\[i\](.*?)\[/i\]#mis', '<i>$1</i>', $string);
		$string = preg_replace('#\[u\](.*?)\[/u\]#mis', '<u>$1</u>', $string);
		$string = preg_replace('#\[hr\]#is', '<hr>', $string);			  
		// Ersatz fr Formatierungen (Links, Farbe, Groesse, Bilder) 
		$bbcode_array['color'] = '<span style="color: $1">$2</span>';
		$bbcode_array['size'] = '<span style="font-size: $1px">$2</span>';
		$bbcode_array['font'] = '<span style="font-family: $1">$2</span>';
			// Hier eine Extra Funktion aufrufen um zu prfen, ob die Breite des Bildes 550px berschreitet
		$bbcode_array['img'] = 'myGB_check_image_size("$1")';
		$bbcode_array['urlb'] = '<a href="{URL}" target="_blank">{DESCRIPTION}</a>'; // In neuem Fenster
		$bbcode_array['urls'] = '<a href="{URL}">{DESCRIPTION}</a>'; // In gleichem Fenster
		$bbcode_array['email'] = '<a href="mailto:{EMAIL}">{EMAIL}</a>';
		$bbcode_array['video'] = '<embed type="application/x-shockwave-flash" src="{LINK}" play="true" loop="true" quality="high" allowscriptaccess="never" height="$2" width="$1"><noembed>&lt;a href=&quot;{LINK}&quot; target=&quot;_blank&quot;&gt;{LINK}&lt;/a&gt;</noembed>';
		// Anpassung der Vorformatierten Links und HTML-Codes von oben
		$bbcode_array['img'] = str_replace('{URL}', 'check_image_size("$1")', $bbcode_array['img']);
		$bbcode_array['url1'] = str_replace('{URL}', '$1', $bbcode_array['urlb']);
		$bbcode_array['url1'] = str_replace('{DESCRIPTION}', '$1', $bbcode_array['url1']);	
		$bbcode_array['url2'] = str_replace('{URL}', 'http://$1', $bbcode_array['urlb']);
		$bbcode_array['url2'] = str_replace('{DESCRIPTION}', '$1', $bbcode_array['url2']);	
		$bbcode_array['url3'] = str_replace('{URL}', '$1', $bbcode_array['urlb']);
		$bbcode_array['url3'] = str_replace('{DESCRIPTION}', '$2', $bbcode_array['url3']);	
		$bbcode_array['url4'] = str_replace('{URL}', 'http://$1', $bbcode_array['urlb']);
		$bbcode_array['url4'] = str_replace('{DESCRIPTION}', '$3', $bbcode_array['url4']);	
		$bbcode_array['url5'] = str_replace('{URL}', '$1', $bbcode_array['urls']);
		$bbcode_array['url5'] = str_replace('{DESCRIPTION}', '$2', $bbcode_array['url5']);	
		$bbcode_array['email'] = str_replace('{EMAIL}', '$1', $bbcode_array['email']);
		$bbcode_array['youtube'] = str_replace('{LINK}', 'http://www.youtube.com/v/$3', $bbcode_array['video']);
		$bbcode_array['myvideo'] = str_replace('{LINK}', 'http://www.myvideo.de/movie/$3', $bbcode_array['video']);
		$bbcode_array['googlevideo'] = str_replace('{LINK}', 'http://video.google.com/googleplayer.swf?docId=$3', $bbcode_array['video']);
		$bbcode_array['clipfish'] = str_replace('{LINK}', 'http://www.clipfish.de/videoplayer.swf?as=0&videoid=$3', $bbcode_array['video']);
		$bbcode_array['other'] = str_replace('{LINK}', '$3', $bbcode_array['video']);
		// Bedingungen fr Ersetzen
		$patterns[] = "#\[img\]([^?](?:[^\[]+|\[(?!url))*?)\[/img\]#mise";
		$replacements[] = $bbcode_array['img'];	
		$patterns[] = "#\[url\]([\w]+?://([\w\#$%&~/.\-;:=,?@:space:\]+]+|\[(?!url=))*?)\[/url\]#mis";
		$replacements[] = $bbcode_array['url1'];	
		$patterns[] = "#\[url\]((www|ftp)\.([\w\#$%&~/.\-;:=,?@:space:\]+]+|\[(?!url=))*?)\[/url\]#mis";
		$replacements[] = $bbcode_array['url2'];	
		$patterns[] = "#\[url=([\w]+?://[\w\#$%&~/.\-;:=,?@:space:\[\]+]*?)\]([^?\n\r\t].*?)\[/url\]#mis";
		$replacements[] = $bbcode_array['url3'];	
		$patterns[] = "#\[url=((www|ftp)\.[\w\#$%&~/.\-;:=,?@:space:\[\]+]*?)\]([^?\n\r\t].*?)\[/url\]#mis";
		$replacements[] = $bbcode_array['url4'];
		$patterns[] = "#\[url=([\w\#$%&~/.\-;:=,?@:space:\[\]+]*?)\]([^?\n\r\t].*?)\[/url\]#mis";
		$replacements[] = $bbcode_array['url5'];	
		$patterns[] = "#\[email\]([a-z0-9&\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\[/email\]#mis";
		$replacements[] = $bbcode_array['email'];
		// Ersetzen der URLs und Bilder von oben
		$string = preg_replace($patterns, $replacements, $string);
		// Farb-, Gren- und Schriftart-Formatierungen
		$string = preg_replace("#\[color=(\#[0-9A-F]{6}|[a-z]+)\](.*?)\[/color\]#mis", $bbcode_array['color'], $string);
		$string = preg_replace("#\[size=([1-2]?[0-9])\](.*?)\[/size\]#mis", $bbcode_array['size'], $string);
		$string = preg_replace("#\[font=([a-z0-9]+)\](.*?)\[/font\]#mis", $bbcode_array['font'], $string);
		// Listen ([list] und [item] bzw. [*])	
		$string = preg_replace("#\[list\](.*?)\[item\]#mis", '[list] [item]', $string);		
		$string = preg_replace("#\[list\](.*?)\[/list\]#mis", '<ul style="list-style-type: circle; margin-top: 0px; margin-bottom: 0px;">$1</ul><br>', $string);
		$string = preg_replace("#\[item\](.*?)\[/item\]((\r\n)*|(\r)*|(\n)*)#mis", '<li>$1</li>', $string);
		$string = preg_replace("#\[\*\](.*?)\[/\*\]((\r\n)*|(\r)*|(\n)*)#mis", '<li>$1</li>', $string);
		// Quotes, Leerzeilen
		$string = preg_replace('#\[quote\](.*?)\[/quote\]#mis', '<div style="padding: 2px; margin: 2px; background-color: #DDDDDD; border: 1px solid black;"><b><small>Quotation:</small></b><br>$1</div>', $string);
		$string = preg_replace('#\[code\](.*?)\[/code\]#mis', '<div style="padding: 2px; margin: 2px; background-color: #DDDDDD; border: 1px solid black; font-family: courier new;"><b><small>Code:</small></b><br>$1'."\r\n</div>", $string);
		$string = preg_replace('#\[php\](.*?)\[/php\]#mise', 'myGB_highlightstring("$1")', $string);
		if($feature == true) // Umbrche nur ersetzen, wenn es sich nicht um eine statische Seite handelt
		{
			$string = preg_replace('#\\\\r\\\\n|\\\\r|\\\\n|\r\n|\r|\n#mis', '<br>', $string);
			$string = preg_replace('#<br />#mis', '', $string);
		}
		// Hier zunchst Links aus Flash-Video-Einbindungen entfernen (nur die IDs behalten)
		$string = preg_replace('#\[flash=(.*?)\]http://youtube.com/watch\?v=(.*?)\[/flash\]#mis', '[flash=$1]$2[/flash]', $string);
		$string = preg_replace('#\[flash=(.*?)\]http://myvideo.de/watch/(.*?)\[/flash\]#mis', '[flash=$1]$2[/flash]', $string);
		$string = preg_replace('#\[flash=(.*?)\]http://google.de/videoplay\?docid=(.*?)\[/flash\]#mis', '[flash=$1]$2[/flash]', $string);
		$string = preg_replace('#\[flash=(.*?)\]http://clipfish.de/player.php?videoid=(.*?)\[/flash\]#mis', '[flash=$1]$2[/flash]', $string);
		$string = preg_replace('#\[flash=(.*?)\]http://www.youtube.com/watch\?v=(.*?)\[/flash\]#mis', '[flash=$1]$2[/flash]', $string);
		$string = preg_replace('#\[flash=(.*?)\]http://www.myvideo.de/watch/(.*?)\[/flash\]#mis', '[flash=$1]$2[/flash]', $string);
		$string = preg_replace('#\[flash=(.*?)\]http://video.google.de/videoplay\?docid=(.*?)\[/flash\]#mis', '[flash=$1]$2[/flash]', $string);
		$string = preg_replace('#\[flash=(.*?)\]http://www.clipfish.de/player.php?videoid=(.*?)\[/flash\]#mis', '[flash=$1]$2[/flash]', $string);
		// Videos von Youtube oder Google Video einfgen ("Flash")		
		$string = preg_replace('#\[flash=([0-9]{1,3}),([0-9]{1,3}),youtube\](.*?)\[/flash\]#mis', $bbcode_array['youtube'], $string);
		$string = preg_replace('#\[flash=([0-9]{1,3}),([0-9]{1,3}),myvideo\](.*?)\[/flash\]#mis', $bbcode_array['myvideo'], $string);
		$string = preg_replace('#\[flash=([0-9]{1,3}),([0-9]{1,3}),googlevideo\](.*?)\[/flash\]#mis', $bbcode_array['googlevideo'], $string);
		$string = preg_replace('#\[flash=([0-9]{1,3}),([0-9]{1,3}),clipfish\](.*?)\[/flash\]#mis', $bbcode_array['clipfish'], $string);
		// Ansonsten normal Flash-Animation (o..) einbinden
		$string = preg_replace('#\[flash=([0-9]{1,3}),([0-9]{1,3})\](.*?)\[/flash\]#mis', $bbcode_array['other'], $string);
		return $string;
	}

?>